<?php
################################################################################
# Natsimhan [Jonathan BURON] - mars 2007 - http://www.natsimhan.com
# Licence Creatice Commons
# http://creativecommons.org/licenses/by-sa/2.0/deed.fr
################################################################################

# fonction permettant de faire tous les calcul en fcontions d'une simple chane
# retourne un tableau contenant toutes les valeurs calcules
function getTabCaptcha($texte="CAPTCHA"){
  $captcha = array(
                    'font'=>array(),
                    'img'=>array(),
                    'txt'=>$texte
                  );
  # Dfinition des paramtres de la police
  $captcha['font']['file'] = 'BorisBlackBloxx.ttf';
  $captcha['font']['size'] = 26;
  # on rcupre les dimensions de l'image du code avec un angle de 0 bien sr
  $captcha['font']['bbox'] = imagettfbbox($captcha['font']['size'],0,$captcha['font']['file'],$captcha['txt']);
  $captcha['font']['w'] =  max($captcha['font']['bbox'][0],
                               $captcha['font']['bbox'][2],
                               $captcha['font']['bbox'][4],
                               $captcha['font']['bbox'][6])
                        -  min($captcha['font']['bbox'][0],
                               $captcha['font']['bbox'][2],
                               $captcha['font']['bbox'][4],
                               $captcha['font']['bbox'][6]);
  $captcha['font']['h'] =  max($captcha['font']['bbox'][1],
                               $captcha['font']['bbox'][3],
                               $captcha['font']['bbox'][5],
                               $captcha['font']['bbox'][7])
                         - min($captcha['font']['bbox'][1],
                               $captcha['font']['bbox'][3],
                               $captcha['font']['bbox'][5],
                               $captcha['font']['bbox'][7]);
  # on calcul les dimensions de l'image qui contiendra le texte
  $captcha['img']['marge'] = 5;
  $captcha['img']['w'] = $captcha['font']['w'] + 2 * $captcha['img']['marge'];
  $captcha['img']['h'] = $captcha['font']['h'] + 2 * $captcha['img']['marge'];
  # on prpare dans des variable les dimensions de coupe : "offset"
  $captcha['img']['x_offset'] = intval($captcha['img']['w']/2);
  $captcha['img']['y_offset'] = intval($captcha['img']['h']/2);
  # on retourne le tableau contenant tous nos calculs
  return $captcha;
}
# on ralise tous les calculs en fonction du texte  placer dans l'image
$captcha = getTabCaptcha("ANTIBOTCSS");
# on test si c'est l'image qui est demande
if(isset($_GET['image'])){
  # on cr l'image qui contiendra le texte
  $img = imagecreatetruecolor($captcha['img']['w'], $captcha['img']['h']);
  # on dfinit la couleur de fond et on colorie le fond avec
  $white = imagecolorallocate($img, 0xFF, 0x99, 0x00);
  imagefill($img,0,0,$white);
  # on dfinit la couleur du texte
  $color_text = imagecolorallocate($img, 0x00,0x00,0x00);
  # on dessine le caractre dans l'image
  imagettftext($img, $captcha['font']['size'], 0, $captcha['img']['marge'], $captcha['img']['marge']+$captcha['font']['h'], $color_text, $captcha['font']['file'], $captcha['txt']);
  # Cration d'un filet noir autour de l'image
  imagerectangle($img, 0, 0, $captcha['img']['w']-1, $captcha['img']['h']-1, imagecolorallocate($img, 0x00,0x00,0x00));
  # on ne coupe que si c'est demand pour l'exercice
  if(isset($_GET['couper'])){
    # on cr une image temporaire pour faire le dcoupage
    $im_tmp = imagecreatetruecolor($captcha['img']['w'], $captcha['img']['h']);
    # on fait les copis-colls horizontaux
    imagecopy($im_tmp,$img,0,0,0,0,$captcha['img']['w'],$captcha['img']['y_offset']);
    imagecopy($img,$img,0,0,0,$captcha['img']['y_offset'],$captcha['img']['w'],$captcha['img']['h']-$captcha['img']['y_offset']);
    imagecopy($img,$im_tmp,0,$captcha['img']['h']-$captcha['img']['y_offset'],0,0,$captcha['img']['w'],$captcha['img']['y_offset']);
    # on fait les copis-colls verticaux si demands
    if($_GET['couper']==2){
      imagecopy($im_tmp,$img,0,0,0,0,$captcha['img']['x_offset'],$captcha['img']['h']);
      imagecopy($img,$img,0,0,$captcha['img']['x_offset'],0,$captcha['img']['w']-$captcha['img']['x_offset'],$captcha['img']['h']);
      imagecopy($img,$im_tmp,$captcha['img']['w']-$captcha['img']['x_offset'],0,0,0,$captcha['img']['x_offset'],$captcha['img']['h']);
    }
    # on supprime la ressource de l'image temporaire
    imagedestroy($im_tmp);
  }
  # On affiche l'image   l'cran (dans le flux http)
  header('Content-Type: image/png');
  header('Cache-control: no-cache, no-store');
  imagepng($img);
  # on supprime la ressource afin de quitter proprement ;-)
  imagedestroy($img);
}
# comme ce n'est pas l'image qui est demande, on affiche la page html
else{
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Un anti-bot en PHP et CSS pas  pas</title>
</head>
<body>
<div>Image gnre en PHP :<br />
<div><img src="index.php?image" alt="Image gnre en PHP" /></div>
</div><div>Image gnre et coupe en 2 en PHP :<br />
<div><img src="index.php?image&amp;couper=1" alt="Image gnre et coupe en PHP" /></div>
</div><div>Image prcdente recompose en CSS :<br />
<div style="display:box;width:<?php echo $captcha['img']['w']; ?>px;height:<?php echo $captcha['img']['h']; ?>px;background:#fff url(index.php?image&amp;couper=1) repeat-y 0 -<?php echo $captcha['img']['h']-$captcha['img']['y_offset']; ?>px;"></div>
</div><div>Image gnre et coupe en 4 en PHP :<br />
<div><img src="index.php?image&amp;couper=2" alt="Image gnre et coupe en PHP" /></div>
</div><div>Image prcdente recompose en CSS :<br />
<div style="display:box;width:<?php echo $captcha['img']['w']; ?>px;height:<?php echo $captcha['img']['h']; ?>px;background:#fff url(index.php?image&amp;couper=2) repeat -<?php echo $captcha['img']['w']-$captcha['img']['x_offset']; ?>px -<?php echo $captcha['img']['h']-$captcha['img']['y_offset']; ?>px;"></div>
</div>
</body>
</html>
<?php
}
?>
